﻿// MainWindow.xaml.cs by Charles Petzold, December 2008
using System;
using System.Diagnostics;
using System.Windows;
using System.Windows.Input;

namespace DataDisplay
{
    public partial class MainWindow : Window
    {
        Stopwatch stopWatch;

        public MainWindow()
        {
            InitializeComponent();
        }

        void OnAttachDataCollectionClick(object sender, RoutedEventArgs args)
        {
            int numPoints;

            if (!Int32.TryParse(numPointsTextBox.Text, out numPoints) ||
                numPoints < 1)
            {
                MessageBox.Show("Value must be positive");
            }

            Cursor = Cursors.Wait;
            stopWatch = Stopwatch.StartNew();

            // Create the data collection (method in DataDisplay#Control.xaml.cs)
            dataDisplayControl.CreateDataCollection(numPoints);

            time1TextBlock.Text = stopWatch.Elapsed.ToString();
            stopWatch.Reset();
            stopWatch.Start();

            // Assign the DataContext (method in DataDisplay#Control.xaml.cs)
            dataDisplayControl.AssignDataContext();

            time2TextBlock.Text = stopWatch.Elapsed.ToString();
            stopWatch.Reset();
            stopWatch.Start();

            // Now the real work begins during layout
            LayoutUpdated += OnLayoutUpdated;
        }

        void OnLayoutUpdated(object sender, EventArgs args)
        {
            time3TextBlock.Text = stopWatch.Elapsed.ToString();
            stopWatch.Stop();
            LayoutUpdated -= OnLayoutUpdated;
            Cursor = Cursors.Arrow;
        }
    }
}
