﻿// DataPointPresenter.cs by Charles Petzold, December 2008
using System;
using System.ComponentModel;
using System.Windows;
using System.Windows.Media;

namespace DataLibrary
{
    public class DataPointPresenter : DataPoint
    {
        static readonly Brush[] _brushes = 
        { 
            Brushes.Red, Brushes.Yellow, Brushes.Green, 
            Brushes.Cyan, Brushes.Blue, Brushes.Magenta 
        };
        Point _variable;
        Brush _brush;
        string _tooltip;

        public Point Variable
        {
            set
            {
                if (_variable != value)
                {
                    _variable = value;
                    OnPropertyChanged("Variable");
                }
            }
            get { return _variable; }
        }

        public Brush Brush
        {
            set
            {
                if (_brush != value)
                {
                    _brush = value;
                    OnPropertyChanged("Brush");
                }
            }
            get { return _brush; }
        }

        public string ToolTip
        {
            set
            {
                if (_tooltip != value)
                {
                    _tooltip = value;
                    OnPropertyChanged("ToolTip");
                }
            }
            get { return _tooltip; }
        }

        protected override void OnPropertyChanged(string propertyName)
        {
            switch (propertyName)
            {
                case "VariableX":
                case "VariableY":
                    Variable = new Point(VariableX, VariableY);
                    goto case "ID";

                case "ID":
                    ToolTip = String.Format("{0}, X={1}, Y={2}",
                                            ID, VariableX, VariableY);
                    break;

                case "Type":
                    Brush = _brushes[Type];
                    break;
            }
            base.OnPropertyChanged(propertyName);
        }
    }
}
