﻿// SingleCellGrid.cs by Charles Petzold, December 2008
using System;
using System.Windows;
using System.Windows.Controls;

namespace DataLibrary
{
    public class SingleCellGrid : Panel
    {
        Size infiniteSize = new Size(Double.PositiveInfinity, Double.PositiveInfinity);
        
        protected override Size MeasureOverride(Size availableSize)
        {
            Size totalSize = new Size();

            foreach (UIElement child in InternalChildren)
            {
                child.Measure(infiniteSize);
                Size childSize = child.DesiredSize;
                totalSize.Width = Math.Max(totalSize.Width, childSize.Width);
                totalSize.Height = Math.Max(totalSize.Height, childSize.Height);
            }

            return totalSize;
        }

        protected override Size ArrangeOverride(Size finalSize)
        {
            foreach (UIElement child in InternalChildren)
            {
                child.Arrange(new Rect(new Point(), child.DesiredSize));
            }

            return finalSize;
        }
    }
}
